package com.example.iplace.main.viewModel.dataView

import android.util.Log
import androidx.compose.foundation.Image
import androidx.compose.foundation.background
import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Row
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.width
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.material3.Button
import androidx.compose.material3.ButtonDefaults
import androidx.compose.material3.Icon
import androidx.compose.material3.IconButton
import androidx.compose.material3.OutlinedTextField
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.ui.draw.clip
import androidx.compose.ui.text.font.Font
import androidx.compose.ui.text.font.FontFamily
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.text.style.TextAlign
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import com.example.iplace.R
import com.example.iplace.main.viewModel.MainViewModel
import com.example.iplace.ui.theme.brown_contrast

import androidx.compose.foundation.clickable
import androidx.compose.foundation.layout.*
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.foundation.lazy.items
//noinspection UsingMaterialAndMaterial3Libraries
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.Add
import androidx.compose.material.icons.filled.Lock
import androidx.compose.material.icons.filled.Menu
import androidx.compose.material.icons.filled.Person
import androidx.compose.material3.DrawerValue
import androidx.compose.material3.DropdownMenu
import androidx.compose.material3.DropdownMenuItem
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.material3.ModalNavigationDrawer
import androidx.compose.material3.Scaffold
import androidx.compose.material3.TopAppBar
import androidx.compose.material3.rememberDrawerState
import androidx.compose.runtime.*
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.layout.ContentScale
import androidx.compose.ui.res.painterResource
import androidx.lifecycle.viewModelScope
import androidx.navigation.NavHostController
import coil.compose.AsyncImage
import com.example.iplace.domain.Constants
import com.example.iplace.model.Category
import com.example.iplace.model.Favourites
import com.example.iplace.model.Place
import com.example.iplace.model.Users
import io.github.jan.supabase.postgrest.from
import kotlinx.coroutines.launch
import kotlinx.serialization.Serializable


@OptIn(ExperimentalMaterial3Api::class)
@Composable
fun MenuV(navController: NavHostController){
    // Объявление ViewModel для работы с данными
    val viewModel = MainViewModel()


// Состояния для хранения списка мест и категорий
// Используем remember для сохранения значений между перекомпозициями
    var placeList by remember { mutableStateOf<List<Place>>(emptyList()) }
    var categoryList by remember { mutableStateOf<List<Category>>(emptyList()) }




    LaunchedEffect(key1 = true) {
        // Получение списка мест из ViewModel и обновление состояния placeList
        placeList = viewModel.getPlaceList()
        // Получение списка категорий из ViewModel и обновление состояния categoryList
        categoryList = viewModel.getCategoryList()
    }

    val selectedCategoryId = remember { mutableStateOf<Int?>(null) }
    val headlinesOswald = FontFamily( //выбор шрифта
        Font(resId = R.font.headlines_oswald)
    )
    val basicNunitosans = FontFamily(
        Font(resId = R.font.basic_nunitosans)
    )


    Image(
        painter = painterResource(id = R.drawable.fon),
        contentDescription = "",
        contentScale = ContentScale.FillHeight,
        modifier = Modifier.fillMaxSize()
    )


    val DrawerState = rememberDrawerState(DrawerValue.Closed)
    ModalNavigationDrawer(
        drawerState = DrawerState,
        modifier = Modifier
            .fillMaxWidth(1f)
        ,

        drawerContent = {
            DrawerContent(navController)
        }
    ) {

        Scaffold(
            topBar = {
                TopAppBar(

                    title = {
                        Row(
                            modifier = Modifier.fillMaxWidth(),
                            horizontalArrangement = Arrangement.SpaceBetween,
                            verticalAlignment = Alignment.CenterVertically
                        ) {
                            IconButton(onClick = { DrawerValue.Open }) {
                                Icon(Icons.Filled.Menu, contentDescription = "Меню")
                            }

                            OutlinedTextField(
                                value = "",
                                onValueChange = {},
                                label = { Text("Поиск") },
                                modifier = Modifier
                                    .fillMaxWidth()
                                    .padding(horizontal = 16.dp)
                                    .weight(1f)
                                    .clip(RoundedCornerShape(20.dp))
                            )

                            IconButton(onClick = { navController.navigate("profile") }) {
                                Icon(Icons.Filled.Person, contentDescription = "Профиль")
                            }
                        }
                    }

                )
            }

        ) { innerPadding ->
            Column(
                modifier = Modifier
                    .fillMaxSize()
                    .padding(innerPadding)
            ) {

                // Кнопка "Фильтр" с выпадающим списком (заглушка)
                Row(
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(16.dp),
                    verticalAlignment = Alignment.CenterVertically
                ) {
                    FilterDropdown(selectedCategoryId)
                    Button(onClick = {
                        selectedCategoryId.value = null
                    }) {
                        Text("Сброс")
                    }
                }
                Text(
                    text = "Лучшие места",
                    fontWeight = FontWeight.Bold,
                    modifier = Modifier
                        .fillMaxWidth(),
                    textAlign = TextAlign.Center
                )

                LazyColumn(
                    contentPadding = PaddingValues(
                        horizontal = 16.dp,
                        vertical = 10.dp
                    ),
                    verticalArrangement = Arrangement.spacedBy(10.dp)
                ) {
                    items(getFilteredPlaceList(placeList, selectedCategoryId)) { place ->
                        PlaceCard(place = place, navController, categoryList = categoryList)
                    }
                }
            }
        }
    }

}



// Функция для фильтрации списка мест по выбранной категории
fun getFilteredPlaceList(placeList: List<Place>, selectedCategoryId: MutableState<Int?>): List<Place> {
    // Проверяем, выбрана ли категория (не равна ли null)
    return if (selectedCategoryId.value != null) {
        // Если категория выбрана, фильтруем список мест по id категории
        placeList.filter { it.id_categoryFK == selectedCategoryId.value }
    } else {
        // Если категория не выбрана, возвращаем весь список мест
        placeList
    }
}



@Composable
fun PlaceCard(place: Place, navController: NavHostController, categoryList: List<Category>) {
    // Инициализация ViewModel для работы с данными
    val viewModel = MainViewModel()
    // Получаем id места
    val placeId = place.id_place
    // Создаем корутину для выполнения асинхронных операций
    val coroutineScope = rememberCoroutineScope()
    // Состояние для управления доступностью кнопки
    var isButtonEnabled by remember { mutableStateOf(true) }

    // Основной контейнер для карточки места
    Box(
        modifier = Modifier
            .fillMaxWidth()
            .height(300.dp)
            .clip(RoundedCornerShape(20.dp))
            .clickable(onClick = {

                navController.navigate("placeV/$placeId")
            }),
        contentAlignment = Alignment.Center
    ) {
        // Асинхронное изображение места
        AsyncImage(
            model = place.img_place,
            contentDescription = null,
            modifier = Modifier.fillMaxSize(),
            contentScale = ContentScale.Crop
        )
        // Накладываемый слой с полупрозрачным черным фоном
        Box(
            modifier = Modifier
                .matchParentSize()
                .background(color = Color.Black.copy(alpha = 0.4f))
                .padding(16.dp)
        ) {
            // Колонка для размещения текста
            Column(
                modifier = Modifier
                    .align(Alignment.BottomStart)
            ) {
                // Заголовок места
                Text(
                    text = place.title,
                    fontSize = 18.sp,
                    color = Color.White
                )
                // Название категории места
                Text(
                    text = categoryList.find { it.id_category == place.id_categoryFK }?.title ?: "Категория не найдена",
                    fontSize = 14.sp,
                    color = Color.White
                )
            }

            // Кнопка для добавления места в избранное
            Button(
                onClick = {
                    isButtonEnabled = false // Отключаем кнопку после нажатия
                    coroutineScope.launch {
                        // Асинхронно добавляем место в избранное
                        viewModel.insertFavourites(idPlace = placeId)
                    }
                },
                modifier = Modifier
                    .align(Alignment.TopEnd)
                    .width(40.dp)
                    .height(40.dp),
                colors = ButtonDefaults.buttonColors(
                    containerColor = if (isButtonEnabled) brown_contrast else Color.Gray, // Цвет кнопки в зависимости от состояния
                    contentColor = Color.Black
                ),
                enabled = isButtonEnabled // Доступность кнопки
            ) {
                // Иконка для кнопки
                Icon(
                    imageVector = Icons.Filled.Add,
                    contentDescription = "Lock icon"
                )
            }
        }
    }
}

@Composable
fun DrawerContent(navController: NavHostController) {
    val headlinesOswald = FontFamily( //выбор шрифта
        Font(resId = R.font.headlines_oswald)
    )
    val basicNunitosans = FontFamily(
        Font(resId = R.font.basic_nunitosans)
    )
    Column(
        modifier = Modifier
            .fillMaxWidth()
            .fillMaxHeight()
            .height(170.dp)
        ,
        horizontalAlignment = Alignment.CenterHorizontally,
        verticalArrangement = Arrangement.Center
    ) {
        //то что находится внутри шторки
        Spacer(modifier = Modifier.height(10.dp))
        Button(
            onClick = { navController.navigate("profile") },
            modifier = Modifier.width(290.dp).height(50.dp),
            colors = ButtonDefaults.buttonColors(brown_contrast)
        ) {
            Text(
                text = "Профиль",
                fontSize = 24.sp,
                fontFamily = basicNunitosans
            )
        }
        Spacer(modifier = Modifier.height(10.dp))
        Button(
            onClick = { navController.navigate("favouritesV") },
            modifier = Modifier.width(290.dp).height(50.dp),
            colors = ButtonDefaults.buttonColors(brown_contrast)
        ) {
            Text(
                text = "Избранное",
                fontSize = 24.sp,
                fontFamily = basicNunitosans
            )
        }
        Spacer(modifier = Modifier.height(10.dp))
        Button(
            onClick = { navController.navigate("addPlace") },
            modifier = Modifier.width(290.dp).height(50.dp),
            colors = ButtonDefaults.buttonColors(brown_contrast)
        ) {
            Text(
                text = "Добавить место",
                fontSize = 24.sp,
                fontFamily = basicNunitosans
            )
        }
        Spacer(modifier = Modifier.height(10.dp))
        Button(
            onClick = { navController.navigate("menuV") },
            modifier = Modifier.width(290.dp).height(50.dp),
            colors = ButtonDefaults.buttonColors(brown_contrast)
        ) {
            Text(
                text = "Меню",
                fontSize = 24.sp,
                fontFamily = basicNunitosans
            )
        }
        Spacer(modifier = Modifier.height(10.dp))
        Button(
            onClick = {  },
            modifier = Modifier.width(290.dp).height(50.dp),
            colors = ButtonDefaults.buttonColors(brown_contrast)
        ) {
            Text(
                text = "Ещё",
                fontSize = 24.sp,
                fontFamily = basicNunitosans
            )
        }
        Spacer(modifier = Modifier.height(10.dp))

    }
}

@Composable
fun FilterDropdown(selectedCategoryId: MutableState<Int?>) {
    val viewModel = MainViewModel()
    var expanded by remember { mutableStateOf(false) }
    val coroutineScope = rememberCoroutineScope()

    var categoryList by remember { mutableStateOf<List<Category>>(emptyList()) }

    LaunchedEffect(key1 = true) {
        categoryList = viewModel.getCategoryList()
    }


    Box() {
        // Кнопка, которая управляет состоянием выпадающего меню
        Button(
            onClick = { expanded = !expanded },
            modifier = Modifier.align(Alignment.CenterStart)
        ) {
            Text("Фильтр")
        }

        // Выпадающее меню, которое отображается, когда expanded равно true
        DropdownMenu(
            expanded = expanded, // Управляемое состояние видимости меню
            onDismissRequest = { expanded = false },
            modifier = Modifier.fillMaxWidth()
        ) {
            // Перебираем список категорий и создаем элементы меню
            categoryList.forEach { category ->
                DropdownMenuItem(
                    onClick = {
                        selectedCategoryId.value = category.id_category // Устанавливаем выбранный ID категории
                        expanded = false // Закрываем меню после выбора категории
                    },
                    text = {
                        Text(category.title) // Отображаем название категории в элементе меню
                    }
                )
            }
        }
    }
}
